//---------------------------------------------------------------------------
#ifndef ParseDemoH
#define ParseDemoH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>         
#include <vcl\Controls.hpp>        
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Dialogs.hpp>

#include <astsbpar.h> //Link necessary header
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
class TFParser : public TForm
{
__published:
	TPanel *PBottom;
	TButton *BExit;
	TPanel *PLeft;
	TPanel *PTop;
	TPanel *PRight;
	TGroupBox *GBVariables;
	TLabel *LxVariable;
	TLabel *LyVariable;
	TLabel *LzVariable;
	TLabel *LuVariable;
	TLabel *LvVariable;
	TLabel *LwVariable;
	TEdit *ExValue;
	TEdit *EyValue;
	TEdit *EzValue;
	TEdit *EuValue;
	TEdit *EwValue;
	TEdit *EvValue;
	TPanel *PClient;
	TGroupBox *GBFunction;
	TMemo *MFunction;
	TPanel *PFTop;
	TPanel *PFBottom;
	TPanel *PFRight;
	TRadioButton *RBDEC;
	TRadioButton *RBBIN;
	TRadioButton *RBHEX;
	TRadioButton *RBOCT;
	TLabel *LBase;
	TPanel *PILeft;
	TLabel *LFunction;
	TPanel *PBottom2;
	TPanel *PLeftOut;
	TPanel *PRightOut;
	TLabel *LBaseOut;
	TRadioButton *RBDECOut;
	TRadioButton *RBBINOut;
	TRadioButton *RBHEXOut;
	TRadioButton *RBOCTOut;
	TPanel *PResult;
	TEdit *EResult;
	TPanel *PTopRight;
	TLabel *LAngle;
	TRadioButton *RBDEG;
	TRadioButton *RBRAD;
	TRadioButton *RBGRA;
	TPanel *IPanel;
	TImage *IPars;
	TLabel *LtheTime;
	TLabel *Lsec;
	TButton *BResult;
	TButton *BOpen;
	TButton *BSave;
	TOpenDialog *DOpen;
	TSaveDialog *DSave;
	TButton *BHelp;
    TButton *BSpeedTest;
    TLabel *LcTime;
    TAnimate *AsbGlobe;
    TButton *BPlotTest;
	void __fastcall BResultClick(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);

	void __fastcall BExitClick(TObject *Sender);

	void __fastcall BSaveClick(TObject *Sender);
	void __fastcall BOpenClick(TObject *Sender);

	void __fastcall BHelpClick(TObject *Sender);

	void __fastcall MFunctionChange(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall BSpeedTestClick(TObject *Sender);
    


    
    
    void __fastcall BPlotTestClick(TObject *Sender);
private:
protected:
   	HANDLE hParser;  //Handle of the sbParser-Object
public:
    void GetBaseAndAngUnit(TForm* pForm, int* BaseIn, int* BaseOut, int* AngularUnit);
    bool GetVarValues(TForm* pForm, int BaseIn, long double varValues[]);
    bool Calculate(TForm* pForm, char* Function, long double varValues[],
        int BaseIn, int BaseOut, int AngularUnit, long double* Result);
public:
	__fastcall TFParser(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern TFParser *FParser;
//---------------------------------------------------------------------------
#endif
